---
title: "v1.3.0 - Moving 5G Core"
date: 2020-07-10 15:26:00 -0400
categories:
  - Release
tags:
  - News
  - Release
head_inline: "<style> ul { padding-bottom: 1em; } </style>"
---

#### What's New?

The Open5GS project has implemented several NFs required for 5G Core(SA). Also, all messages have been changed to Release-16. Therefore, EPC can support NSA, ENDC, CUPS, etc.

However, the package contains only MME/SGW/PGW/HSS/PCRF. If the tests are fully verified, I will include other NFs in the package later. You'll need to compile the source code for the time being to use added features.
- To use CUPS, you need to run NRF/SMF/UPF instead of PGW.
- 5G Core installation is described in this [LINK](/open5gs/docs/guide/02-building-open5gs-from-sources/)

Next, I am considering the separation of SGW-C/SGW-U to implement full CUPS functionality. And, if I have more time, I would like to add NB-IoT function.

#### Enhancement
- Select SGW/UPF ([#470](https://github.com/open5gs/open5gs/pull/470)) -- [kbarlee](https://github.com/kbarlee)
- Add MSISDN IE to Create Session Request message ([#464](https://github.com/open5gs/open5gs/issues/464)) -- [Davied-Dh](https://github.com/Davied-Dh)
- Add the modified Bearer level QoS if PCRF changes them ([#457](https://github.com/open5gs/open5gs/pull/457)) -- [herlesupreeth](https://github.com/herlesupreeth)
- Adding MMEName to S1SetupResponse([#444](https://github.com/open5gs/open5gs/issues/444)) -- [Matheus-Garbelini](https://github.com/Matheus-Garbelini)

#### Bug Fixed
- Remove assert for UEContextReleaseComplete ([#445](https://github.com/open5gs/open5gs/issues/445)) -- [Matheus-Garbelini](https://github.com/Matheus-Garbelini)
- Undo the fix provided for converting Rx to Gx Flow Description ([#452](https://github.com/open5gs/open5gs/pull/452)) -- [herlesupreeth](https://github.com/herlesupreeth)
- Switch UL/DL Values in WebUI ([#450](https://github.com/open5gs/open5gs/pull/450)) -- [nickvsnetworking](https://github.com/nickvsnetworking)
- SMF crash after unknown UPF peer tries to connect on N4 ([#437](https://github.com/open5gs/open5gs/issues/437)) -- [kbarlee](https://github.com/kbarlee)
- eNB connection when maximum number of eNBs reached ([#423](https://github.com/open5gs/open5gs/pull/423)) -- [jamofer](https://github.com/jamofer)
- PGW crashes if diameter pool is exhausted ([#420](https://github.com/open5gs/open5gs/issues/420)) -- [laf0rge](https://github.com/laf0rge)

#### Document
- Update URL in WebUI installation document ([#495](https://github.com/open5gs/open5gs/issues/495)) -- [Mopoma95](https://github.com/Mopoma95)
- Update VoLTE tutorial ([#459](https://github.com/open5gs/open5gs/pull/459)) -- [herlesupreeth](https://github.com/herlesupreeth)
- VoLTE Document improvement(IPsec works now) ([#424](https://github.com/open5gs/open5gs/pull/424)) -- [miaoski](https://github.com/miaoski)


Download -- [v1.3.0.tar.gz](https://github.com/open5gs/open5gs/archive/v1.3.0.tar.gz)
{: .notice--info}
